# --- BEGIN COPYRIGHT BLOCK ---
# Copyright (C) 2015 Red Hat, Inc.
# All rights reserved.
#
# License: GPL (version 3 or any later version).
# See LICENSE for details.
# --- END COPYRIGHT BLOCK ---

from lib389._constants import *
from flask import Blueprint, request, jsonify

from .Authentication import authenticateConnection
from .Helpers import jsonResponse

monitor_api = Blueprint('monitor_api', __name__)


@monitor_api.route('/v1/monitor', methods=['GET', 'HEAD', 'OPTIONS'])
@authenticateConnection
def monitor(ds):

    if request.method == 'OPTIONS':
        msg = {}
        msg['allow'] = 'GET OPTIONS HEAD'
        return jsonify(msg)

    elif request.method == 'HEAD':
        # Probably should be checking if it exists here ...
        return jsonResponse("", 200, request.url)

    elif request.method == 'GET':
        status = ds.monitor.server()
        return jsonResponse(status, 200, request.url)

# We might make a suffix monitor later, so we leave the namespace clean.

@monitor_api.route('/v1/monitor/backend', methods=['GET', 'HEAD', 'OPTIONS'])
@authenticateConnection
def monitor_backends(ds):

    # Is there a magic way to auto generate these options through intro spection?
    if request.method == 'OPTIONS':
        msg = {}
        msg['allow'] = 'GET OPTIONS HEAD'
        return jsonify(msg)

    elif request.method == 'HEAD':
        # Probably should be checking if it exists here ...
        return jsonResponse("", 200, request.url)

    elif request.method == 'GET':
        status = ds.monitor.backends()
        print(status)
        return jsonResponse(status, 200, request.url)


@monitor_api.route('/v1/monitor/backend/<backend>', methods=['GET', 'HEAD', 'OPTIONS'])
@authenticateConnection
def monitor_backend(ds, backend):

    # Is there a magic way to auto generate these options through intro spection?
    if request.method == 'OPTIONS':
        msg = {}
        msg['allow'] = 'GET OPTIONS HEAD'
        return jsonify(msg)

    elif request.method == 'HEAD':
        # Probably should be checking if it exists here ...
        return jsonResponse("", 200, request.url)

    elif request.method == 'GET':
        status = ds.monitor.backend(backend)
        print(status)
        return jsonResponse(status, 200, request.url)

